"use strict";

/**
 * Class used for javascript operations on SearchPanel
 * 
 * @param searchInput
 *            HTML input where search query is placed
 * 
 * @param searchButton
 *            HTML button used to send query to the server
 * 
 */
function SearchPanel(searchInput, searchButton, focusSearchResultMethod) {
  this.searchInput = searchInput;
  this.searchButton = searchButton;
  if (focusSearchResultMethod === "undefined") {
    this.focusSearchResults = function() {
    };
  } else {
    this.focusSearchResults = focusSearchResultMethod;
  }
}

/**
 * Executes query search.
 * 
 * @param query
 *            that we wants to perform
 * 
 */
SearchPanel.prototype.search = function(query) {
  if (query !== "undefined") {
    this.searchInput.value = query;
  }
  this.searchButton.click();
  this.focusSearchResults();
};

module.exports = SearchPanel;
