"use strict";

require("./mocha-config.js");

var Project = require('../../main/js/map/data/Project');
var minerva = require('../../main/js/minerva');

var chai = require('chai');
var assert = chai.assert;
var logger = require('./logger');

describe('minerva global', function() {


  it('create', function() {
    var map = new google.maps.Map(testDiv, {
      center : {
        lat : -34.397,
        lng : 150.644
      },
      scrollwheel : false,
      zoom : 8
    });
    var project = new Project({
      map : {
        layouts : [ {
          name : "Pathways and compartments",
          idObject : 14081
        } ],
      },
    });
    
    var options = {
      map : map,
      project : project,
      dataCollections : [ {
        name : "testCollection"
      } ],
    };

    var result = minerva.create(options);
    assert.ok(result);
    assert.equal(logger.getWarnings().length, 4);
  });
});
